## pay.tar.bz2

=== Makefile ===
UNAME_S := $(shell uname -s)
migrations_root := /tmp/bill_payments-dev-migrations-root
arcadia_root := $(shell ya dump root)
params := $(wordlist 2,100,$(MAKECMDGOALS))
no_db_recipe := DB_USE_ARCADIA_RECIPE=False
source_root := Y_PYTHON_SOURCE_ROOT=$(arcadia_root)
entry_point := Y_PYTHON_ENTRY_POINT=":main"
pytest_args := -m pytest -p no:warnings -sv


# Code style

ya-style:
	ya style

mypy:
	MYPYPATH=$(arcadia_root) mypy -p pay.bill_payments --show-traceback --disallow-incomplete-defs

sort-imports:
	isort bill_payments/

check-isort:
	isort --check-only --diff bill_payments/

cc: sort-imports ya-style mypy


# Tests
test:
	ya make -tt --test-stdout

test-unit:
	ya make -tt --test-stdout bill_payments/tests/unit

test-functional:
	ya make -tt --test-stdout bill_payments/tests/functional

dev-unit:
	$(no_db_recipe) $(source_root) $(entry_point) ./python/python $(pytest_args) $(if $(params),$(params),bill_payments/tests/unit)

dev-functional:
	$(no_db_recipe) $(source_root) $(entry_point) ./python/python $(pytest_args) $(if $(params),$(params),bill_payments/tests/functional)


# Development
deps:
	ya make --checkout bill_payments && ya make --checkout bill_payments/tests

build_bin:
	ya make bin

build_docker: build_bin
	ya package package/package.json --docker --docker-repository pay/bill_payments --custom-version 0.0.0-$(shell date +"%s")

runserver:
	$(source_root) ./bin/bill_payments runserver

l_runserver:
	./run_local.sh make runserver

wl_runserver:
	./run_local.sh -w make runserver

runworkers:
	$(source_root) ./bin/bill_payments runworkers

l_runworkers:
	./run_local.sh make runworkers

wl_runworkers:
	./run_local.sh -w make runworkers

shell:
	$(source_root) ./bin/bill_payments shell

l_shell:
	./run_local.sh make shell

tunnel:
	# Определи алиас billpayments-dev в ~/.ssh/config
	ssh -D 4444 billpayments-dev -N


# Deployment
yadeploy-testing:
	ya tool dctl put stage ./deploy/bill-payments-testing.deploy.yaml

yadeploy-load:
	ya tool dctl put stage ./deploy/bill-payments-load.deploy.yaml

yadeploy-production:
	ya tool dctl publish-draft stage ./deploy/bill-payments-production.deploy.yaml

sync-deploy-spec:
	ya tool dctl get stage bill-payments-testing > ./deploy/bill-payments-testing.deploy.yaml
	ya tool dctl get stage bill-payments-production > ./deploy/bill-payments-production.deploy.yaml

# Database
start_db:
ifeq ($(UNAME_S),Linux)
	# докер в убунте не может делать bind volume на директорию аркадии, смонтированной через arc
	rm -rf $(migrations_root) && mkdir -p $(migrations_root) && cp -r ./postgre $(migrations_root)
	BILL_PAYMENTS_MIGRATIONS_ROOT=$(migrations_root) docker-compose up -d bill_payments_db bill_payments_db_migrated
else
	docker-compose up -d bill_payments_db bill_payments_db_migrated
endif

pgcli:
	PGPASSWORD="P@ssw0rd" pgcli -h localhost -p 5252 -U bill_payments -d bill_payments_db

restart_db:
	docker-compose rm --force --stop -v bill_payments_db bill_payments_db_migrate bill_payments_db_migrated
	make start_db

=== tools/docker-images/base/Makefile ===
DOCKER_IMAGE	?= registry.yandex.net/yandex-pay/frontend/base
DOCKER_TAG		?= stable

build:
	docker build --pull --no-cache -t $(DOCKER_IMAGE):$(DOCKER_TAG) .

publish:
	docker push $(DOCKER_IMAGE):$(DOCKER_TAG)

.PHONY: build publish

=== debian/changelog ===
yandex-duckgo (1.5.1) unstable; urgency=low

   See arc diff tags/releases/pay/duckgo/v1.4.0 tags/releases/pay/duckgo/v1.5.1 for full log
 -- ivaxer <ivaxer@yandex-team.ru>  Fri, 08 Jul 2022 10:52:01 +0300

yandex-duckgo (1.4.0) unstable; urgency=low

   See git@github.yandex-team.ru:yandex-pay/duckgo.git for full log
   * dd1b701 YANDEXPAY-2933. mastercard: kids logging, verification keys handling
   * 7bdd595 YANDEXPAY-2958. Visa: superkeys support in /paymentData
   * ed5720c Refactor testPSP.
   * d945541 YANDEXPAY-3025. Add ECI for visa token
   * f99aeae YANDEXPAY-3023. Update go to 1.17.5
   * 9666589 YANDEXPAY-2578. Disable stacktrace
   * 050ef1d YANDEXPAY-2462. Move to yandex-pay gh org.
   * c0f9dea YANDEXPAY-2061. Rotate mastercard keys.
   * ef2b3a4 v1.3.0
   * 4f24807 YANDEXPAY-1814. make-payment-token: fix token expiration
   * e1f3fe8 YANDEXPAY-1588 шифрование карты для Thales
 -- Ivan Khvatov <ivaxer@yandex-team.ru>  Wed, 29 Dec 2021 17:07:09 +0300

yandex-duckgo (1.3.0) unstable; urgency=low

   See git@github.yandex-team.ru:Billing/duckgo.git for full log
   * 4f24807 YANDEXPAY-1814. make-payment-token: fix token expiration
   * e1f3fe8 YANDEXPAY-1588 шифрование карты для Thales
 -- perseus <perseus@yandex-team.ru>  Fri, 6 Aug 2021 13:51:59 +0400

yandex-duckgo (1.2.6) unstable; urgency=low

   See git@github.yandex-team.ru:Billing/duckgo.git for full log
   * f806c00 Fix generate-local-config.bash
   * 0fa5c40 YANDEXPAY-1654. Fix relationshipID parameter.
 -- Ivan Khvatov <ivaxer@yandex-team.ru>  Fri, 16 Jul 2021 12:13:09 +0400

yandex-duckgo (1.2.5) unstable; urgency=low

   See git@github.yandex-team.ru:Billing/duckgo.git for full log
   * 97cea69 YANDEXPAY-1659. Update go 1.16.6
   * cca77ae YANDEXPAY-1654. Visa relationship id support
   * b225ee0 YANDEXPAY-1652. Correlation headers forwarding and logging
   * 88a8958 YANDEXPAY-1431. mastercard mock: Required fields in MaskedCard.
   * 143a8af YANDEXPAY-1417. Add verification key in sandbox
 -- Ivan Khvatov <ivaxer@yandex-team.ru>  Fri, 16 Jul 2021 11:07:58 +0400

yandex-duckgo (1.2.4) unstable; urgency=low

   See git@github.yandex-team.ru:Billing/duckgo.git for full log
   * df6ea61 YANDEXPAY-1420. Fix visa correlation/response-ids logging
 -- Ivan Khvatov <ivaxer@yandex-team.ru>  Fri, 4 Jun 2021 16:48:48 +0300

yandex-duckgo (1.2.3) unstable; urgency=low

   See git@github.yandex-team.ru:Billing/duckgo.git for full log
   * e1cd2ca YANDEXPAY-1241 sort query params before signing
   * a1c9a3d YANDEXPAY-1204 client_payment_data_id is provided by client
 -- Ivan Khvatov <ivaxer@yandex-team.ru>  Wed, 12 May 2021 16:06:21 +0300

yandex-duckgo (1.2.2) unstable; urgency=low

   See git@github.yandex-team.ru:Billing/duckgo.git for full log
   * f2498af YANDEXPAY-496. Fix TestExampleConfig after 8ab79ac90
   * 8bc648c YANDEXPAY-1116. Use log.Duration
   * 68e7a46 YANDEXPAY-1116. Enable log levels
   * 2449413 YANDEXPAY-1116. Switch to ctxlog
   * 7191f42 YANDEXPAY-1116. Switch to arcadia logger
   * 8ab79ac YANDEXPAY-496. generate-local-config: verification key & visa
   * ace1c26 YANDEXPAY-893. Add handler to verify recipient key.
   * 4f1880b YANDEXPAY-496. Cleanup RecipientKeySigner API
   * 0dac0cc YANDEXPAY-496. Recipient public key verification.
   * 5257472 YANDEXPAY-496. Implement verifier
   * 1338551 YANDEXPAY-496. Use custom clock in recipient key signer.
   * 52241b2 YANDEXPAY-1083 visa support multiple outbound keys
   * 01fa3cc YANDEXPAY-1090: make-payment-token: gateway-merchant-id option
   * 08af676 YANDEXPAY-1079. Don't require cardholderFullName
   * 6593b3c YANDEXPAY-1066: use outbound key for signature checking
 -- Ivan Khvatov <ivaxer@yandex-team.ru>  Tue, 20 Apr 2021 19:24:22 +0300

yandex-duckgo (1.2.1) unstable; urgency=low

   See git@github.yandex-team.ru:Billing/duckgo.git for full log
   * d4335f0 YANDEXPAY-495. Change signing key format.
   * 6687141 remove tab from log
 -- Ivan Khvatov <ivaxer@yandex-team.ru>  Mon, 12 Apr 2021 18:31:50 +0300

yandex-duckgo (1.2.0) unstable; urgency=low

   See git@github.yandex-team.ru:Billing/duckgo.git for full log
   * 4df7522 YANDEXPAY-1029. Add sign-recipient-key to deb package
   * 009bfa6 YANDEXPAY-980. Renames for new arcadia TVM client
   * 3a11b52 visa checkout api change param name emailHash -> email_hash
   * 20cea8a YANDEXPAY-495. Add clockwork dep
   * 353fa12 YANDEXPAY-495. Implement sign-recipient-key
   * ec5d059 YANDEXPAY-776. mastercard: don't send empty cardholderFullName
   * 8a19f5f YANDEXPAY-921. Add yandex-boinic-testing repo
   * ad1b373 YANDEXPAY-915. Fix mastercard test flapping.
   * 46a27f1 YANDEXPAY-891. debian: update go to 1.16.2
   * b922ccc YANDEXPAY-73 check signature handler
   * 260a3d7 YANDEXPAY-266 fix naming query -> url
   * bd5e5b9 YANDEXPAY-820 disable visa from config
   * d3a24a1 YANDEXPAY-268 visa api support: enroll/checkout card, sign visa request
   * afa9a51 YANDEXPAY-676. Replace mocked Mastercard's DPAN.
   * c2c40d4 YANDEXPAY-184 update makefile
   * 1151e8b YANDEXPAY-676. Replace sandbox cards.
   * 1efb936 YANDEXPAY-184 sandbox deploy scripts
 -- Ivan Khvatov <ivaxer@yandex-team.ru>  Tue, 6 Apr 2021 15:15:26 +0300

yandex-duckgo (1.1.3) unstable; urgency=low

   See git@github.yandex-team.ru:Billing/duckgo.git for full log
   * a4d4ca0 Set cache file mode to 640 YANDEXPAY-642
 -- Ivan Khvatov <ivaxer@yandex-team.ru>  Tue, 16 Feb 2021 17:59:00 +0300

yandex-duckgo (1.1.2) unstable; urgency=low

   See git@github.yandex-team.ru:Billing/duckgo.git for full log
   * b85aee4 YANDEXPAY-484. Fix changelog generator
   * c4c08ca Fix TestCache YANDEXPAY-628
   * ada7f56 YANDEXPAY-484. deb: add build and compare bash scripts
   * ae739d7 debian: update go to 1.15.8
   * 3a451b5 YANDEXPAY-584. Rename CRYPTOGRAM_3DS to CLOUD_TOKEN.
   * 5ed8203 checkstyle
   * c53e4e4 YANDEXPAY-133 review issues
   * 50fd6ab YANDEXPAY-184 add sandbox cards
   * 04e2e75 YANDEXPAY-481. Add mastercad keys cache to example config


=== debian/control ===
Source: yandex-duckgo
Maintainer: Ivan Khvatov <ivaxer@yandex-team.ru>
Build-Depends: debhelper (>= 11)

Package: yandex-duckgo
Architecture: any
Description: Cryptography API for Yandex Pay

=== debian/rules ===
#!/usr/bin/make -f

PACKAGEVERSION := $(shell dpkg-parsechangelog | sed -nE 's/^Version: (.*)/\1/p')
BUILD_CMD := /usr/local/go/bin/go build -v -trimpath -ldflags=-buildid=v$(PACKAGEVERSION)

%:
	dh $@

override_dh_auto_clean:
override_dh_auto_test:
	/usr/local/go/bin/go test ./...

override_dh_auto_build:
override_dh_auto_install:
	$(BUILD_CMD) ./cmd/duckgo
	$(BUILD_CMD) ./cmd/sign-recipient-key

override_dh_gencontrol:
	dh_gencontrol -- -v$(PACKAGEVERSION)

override_dh_strip:
	# disable strip
